regina::NormalSurfaceVector Class Referenceabstract
Normal Surfaces

Stores the vector of a single normal surface in a 3-manifold. More...

`#include <surfaces/normalsurface.h>`

Inheritance diagram for regina::NormalSurfaceVector:

## Public Member Functions

| NormalSurfaceVector (size_t length)
| Creates a new vector all of whose entries are initialised to zero. More...
| NormalSurfaceVector (const Vector< LargeInteger > &cloneMe)
| Creates a new vector that is a clone of the given vector. More...
virtual | ~NormalSurfaceVector ()
| A virtual destructor. More...
const Ray & | coords () const
| Gives read-only access to the underlying vector of coordinates. More...
virtual NormalSurfaceVector * | clone () const =0
| Creates a newly allocated clone of this vector. More...
size_t | size () const
| Returns the number of coordinates in the underlying vector. More...
const NLargeInteger & | operator[] (size_t index) const
| Returns the given coordinate from the underlying vector. More...
virtual void | setElement (size_t index, const LargeInteger &value)
| Sets the given normal coordinate to the given value. More...
virtual void | operator+= (const NormalSurfaceVector &other)
| Adds the given vector to this vector. More...
virtual void | scaleDown ()
| Scales this vector down by the greatest common divisor of all its elements. More...
virtual bool | allowsAlmostNormal () const =0
| Determines if the specific underlying coordinate system allows for almost normal surfaces, that is, allows for octagonal discs. More...
virtual bool | allowsSpun () const =0
| Determines if the specific underlying coordinate system allows for spun-normal surfaces; that is, surfaces with infinitely many triangles. More...
virtual bool | allowsOriented () const =0
| Determines if the specific underlying coordinate system allows for transversely oriented normal surfaces. More...
virtual bool | hasMultipleOctDiscs (const Triangulation< 3 > *triang) const
| Determines if this normal surface has more than one octagonal disc. More...
virtual bool | isCompact (const Triangulation< 3 > *triang) const
| Determines if the normal surface represented is compact (has finitely many discs). More...
virtual bool | isVertexLinking (const Triangulation< 3 > *triang) const
| Determines if the normal surface represented is vertex linking. More...
virtual const Vertex< 3 > * | isVertexLink (const Triangulation< 3 > *triang) const
| Determines if a rational multiple of the normal surface represented is the link of a single vertex. More...
virtual std::pair< const Edge< 3 > *, const Edge< 3 > * > | isThinEdgeLink (const Triangulation< 3 > *triang) const
| Determines if a rational multiple of the normal surface represented is the thin link of a single edge. More...
virtual bool | isSplitting (const Triangulation< 3 > *triang) const
| Determines if the normal surface represented is a splitting surface in the given triangulation. More...
virtual LargeInteger | isCentral (const Triangulation< 3 > *triang) const
| Determines if the normal surface represented is a central surface in the given triangulation. More...
virtual LargeInteger | triangles (size_t tetIndex, int vertex, const Triangulation< 3 > *triang) const =0
| Returns the number of triangular discs of the given type in this normal surface. More...
virtual LargeInteger | orientedTriangles (size_t tetIndex, int vertex, const Triangulation< 3 > *triang, bool orientation) const
| Returns the number of oriented triangular discs of the given type in this normal surface. More...
virtual LargeInteger | quads (size_t tetIndex, int quadType, const Triangulation< 3 > *triang) const =0
| Returns the number of quadrilateral discs of the given type in this normal surface. More...
virtual LargeInteger | orientedQuads (size_t tetIndex, int quadType, const Triangulation< 3 > *triang, bool orientation) const
| Returns the number of oriented quadrilateral discs of the given type in this normal surface. More...
virtual LargeInteger | octs (size_t tetIndex, int octType, const Triangulation< 3 > *triang) const =0
| Returns the number of octagonal discs of the given type in this normal surface. More...
virtual LargeInteger | edgeWeight (size_t edgeIndex, const Triangulation< 3 > *triang) const =0
| Returns the number of times this normal surface crosses the given edge. More...
virtual LargeInteger | arcs (size_t triIndex, int triVertex, const Triangulation< 3 > *triang) const =0
| Returns the number of arcs in which this normal surface intersects the given triangle in the given direction. More...

## Static Public Member Functions

static NormalSurfaceVector * | makeZeroVector (const Triangulation< 3 > *triangulation)
| Returns a new normal surface vector of the appropriate length for the given triangulation and for the coordinate system corresponding to this subclass of NormalSurfaceVector. More...
static MatrixInt * | makeMatchingEquations (const Triangulation< 3 > *triangulation)
| Creates a new set of normal surface matching equations for the given triangulation using the coordinate system corresponding to this particular subclass of NormalSurfaceVector. More...
static EnumConstraints * | makeEmbeddedConstraints (const Triangulation< 3 > *triangulation)
| Creates a new set of validity constraints representing the condition that normal surfaces be embedded. More...

## Protected Attributes

Ray | coords_
| The raw vector of normal coordinates. More...

## Detailed Description

Stores the vector of a single normal surface in a 3-manifold.

The different subclasses of NormalSurfaceVector use different underlying coordinate systems for the normal solution space. However, the various coordinate retrieval routines will return values that are independent of the underlying coordinate system. Thus the coordinates of the normal surface in any coordinate system can be determined without knowledge of the specific underlying coordinate system being used.

Note that non-compact surfaces (surfaces with infinitely many discs, such as spun-normal surfaces) are allowed; in these cases, the corresponding coordinate lookup routines should return LargeInteger::infinity where appropriate.

All subclasses of NormalSurfaceVector must have the following properties:

- Normal surfaces can be enumerated by intersecting the non-negative orthant of the underlying vector space with some linear subspace;
- Adding two normal surfaces corresponds to adding the two underlying vectors.

When deriving classes from NormalSurfaceVector:

- A new value must must be added to the NormalCoords enum in normalcoords.h to represent the new coordinate system.
- The file coordregistry-impl.h must be updated to reflect the new coordinate system (the file itself contains instructions on how to do this).
- A corresponding specialisation of NormalInfo<> must be defined, typically in the same header as the new vector subclass.
- The macro REGINA_NORMAL_SURFACE_FLAVOUR must be added to the beginning of the new vector subclass. This will declare and define various constants, typedefs and virtual functions (see the REGINA_NORMAL_SURFACE_FLAVOUR macro documentation for details).
- Constructors `class(size_t length)` and `class(const Vector<LargeInteger>& cloneMe)` must be declared and implemented; these will usually just call the corresponding superclass constructors.
- All abstract functions must be implemented, except for those already provided by REGINA_NORMAL_SURFACE_FLAVOUR. Note that coordinate functions such as triangles() must return the total number of discs of the requested type; if your new coordinate system adorns discs with extra information (such as orientation) then your implementation must compute the appropriate sum.
- The orientation-specific coordinate functions orientedTriangles() and orientedQuads() must be implemented if your coordinate system supports transverse orientation. Otherwise you can use the default implementations (which returns zero).
- Static public functions `void makeZeroVector(const Triangulation<3>*)`, `MatrixInt* makeMatchingEquations(const Triangulation<3>*)` and makeEmbeddedConstraints(const Triangulation<3>*) must be declared and implemented.

Todo:
  Optimise (long-term): Investigate using sparse vectors for storage.

Python:\n Not present.

The documentation for this class was generated from the following file:

- surfaces/normalsurface.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).